/*################################################
  ##	Student ID:		1640608					##  
  ##	Student Name:	Peter Ghawi 			##
  ##	Student Email:	Ghawip@cardiff.ac.uk	##
  ################################################*/
package hs110;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Properties;
import java.util.Scanner;

public class RunAttack {
	 private static Console con;
	 private static UserInterface UserInterface;

	 public static void main(String[] args) {
		 String cnf = args[0];
	        try {
	        	UserInterface.showMain();
	        	Console.print(UserInterface.InputMsg());
	        	// Catch user's input
	            String ans = con.readString();	            
	            //If input is not exit create an attack
	            do{
	            	// if the input of the user is not exit or rand or help or steal and is not found in the list generated in checkArgs() then ask the user again.
	            	while(!ans.equalsIgnoreCase("exit") && !checkArgs(cnf,ans) && !ans.equalsIgnoreCase("rand") && !ans.equalsIgnoreCase("help") && !ans.equalsIgnoreCase("steal")) {
	            	Console.println(UserInterface.InputErrorMsg());
            		Console.println(UserInterface.ReMsg());
            		Console.print(UserInterface.InputMsg());
	            	ans = con.readString();
	            	}
	            	// if the input is exit terminate
 	            	if (ans.equalsIgnoreCase("exit")) {
 	            		Console.println(UserInterface.TerminateMsg());
 	            		break;
 	            	}
 	            	// if the input is help print out the options which can be found in the UseInterface class
 	            	if (ans.equalsIgnoreCase("help")) {
 		  	           	UserInterface.showOptions();
 		  	           	Console.println(UserInterface.ReMsg());
 		  	           	Console.print(UserInterface.InputMsg());
 		  	           	ans = con.readString();
 		  	        } 
	            		 while(!ans.isBlank()) {
	            			 //if the input is not blank then create the attack depending on the input of the user.
	            			AttackFactory atk_Factory = AttackGenerator.generateAttack(ans);
	     		  	        Attack current_atk = atk_Factory.createAttack(cnf);
	     		  	        current_atk.launchAttack(cnf);
	     		  	        Console.println(UserInterface.ReMsg());
	     		  	        Console.print(UserInterface.InputMsg());
	     		  	        //ask for another command or exit
	     		  	        ans = con.readString();	   
	     		  	        break;
	     	            }
	     	                    	
	          }while(!ans.isBlank());
	        } catch (Exception e) {
	        	Console.println(UserInterface.TerminateMsg());
	  
	        }
	    }
	 //checks if the input of the user is found in a list that is generated by taking the first word of every line from the config file.
	 //i.e. it take the name of the commands and makes a list, depending on the user input it will either return true or false. True if
	 // input of the user is found in the list and false otherwise.
	 public static boolean checkArgs(String arg, String ans) {
		try {
		   	File myObj = new File(arg);
		    Scanner myReader = new Scanner(myObj);
		    ArrayList<String> myList = new ArrayList<String>();
		    while (myReader.hasNextLine()) {
		    	String data = myReader.nextLine();
		        String cmd[] = data.split(" =",2);
		        myList.add(cmd[0]);
		      }
            boolean test = myList.contains(ans);
		    return test;
		 }catch(Exception e) {
			 e.printStackTrace();
		 }
		return false;
	 }
}
